#ifndef DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXPACKAGEHEADER_INC
#define DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXPACKAGEHEADER_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_PackageHeader.h"

#include "Dx_L1Entry.h"
#include "Dx_L2EntryNew.h"
#include "Dx_L2EntryUpdate.h"
#include "Dx_BittrexTradeEntry.h"
#include "Dx_BookResetEntry.h"
using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::qsrv::hf::plugins::data::bittrex::types {

class Dx_BittrexPackageHeader : public dx_BITTREX::deltix::timebase::api::messages::universal::Dx_PackageHeader {
private:
    std::string __class_type__ = "deltix.qsrv.hf.plugins.data.bittrex.types.BittrexPackageHeader";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1f";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_PackageHeader::decode(reader);
        int32_t size_entries_ = reader.readArrayStart();
        if (size_entries_ == INT32_NULL) {has_entries_ = false; } else {
            has_entries_ = true;
            entries_.resize(size_entries_);
            for (int i_entries_ = 0; i_entries_ < size_entries_; ++i_entries_) {
                int32_t type_entries__i_entries___ = reader.readObjectStart();
                if (type_entries__i_entries___ == Constants::INT32_NULL) {
                    entries_[i_entries_] = nullptr;
                } else if (type_entries__i_entries___ == 0) {
                    entries_[i_entries_] = shared_ptr<NativeMessage>(new dx_BITTREX::deltix::timebase::api::messages::universal::Dx_L1Entry());
                    entries_[i_entries_]->decode(reader);
                    reader.readObjectEnd();
                } else if (type_entries__i_entries___ == 1) {
                    entries_[i_entries_] = shared_ptr<NativeMessage>(new dx_BITTREX::deltix::timebase::api::messages::universal::Dx_L2EntryNew());
                    entries_[i_entries_]->decode(reader);
                    reader.readObjectEnd();
                } else if (type_entries__i_entries___ == 2) {
                    entries_[i_entries_] = shared_ptr<NativeMessage>(new dx_BITTREX::deltix::timebase::api::messages::universal::Dx_L2EntryUpdate());
                    entries_[i_entries_]->decode(reader);
                    reader.readObjectEnd();
                } else if (type_entries__i_entries___ == 3) {
                    entries_[i_entries_] = shared_ptr<NativeMessage>(new Dx_BittrexTradeEntry());
                    entries_[i_entries_]->decode(reader);
                    reader.readObjectEnd();
                } else if (type_entries__i_entries___ == 4) {
                    entries_[i_entries_] = shared_ptr<NativeMessage>(new dx_BITTREX::deltix::timebase::api::messages::universal::Dx_BookResetEntry());
                    entries_[i_entries_]->decode(reader);
                    reader.readObjectEnd();
                } else {
                    throw runtime_error("Unknown class type");
                }
            }
            reader.readArrayEnd();
        }
    }

    virtual void encode(DataWriter &writer) {
        Dx_PackageHeader::encode(writer);
        if (!has_entries_) { writer.writeArrayNull(); } else {
            writer.writeArrayStart(entries_.size());
            for (int i_entries_ = 0; i_entries_ < entries_.size(); ++i_entries_) {
                if (entries_[i_entries_] == nullptr) { writer.writeObjectNull(); } else {
                    if (!entries_[i_entries_]->getTypeName().compare("deltix.timebase.api.messages.universal.L1Entry")) {
                        writer.writeObjectStart(0);
                        entries_[i_entries_]->encode(writer);
                        writer.writeObjectEnd();
                    } else if (!entries_[i_entries_]->getTypeName().compare("deltix.timebase.api.messages.universal.L2EntryNew")) {
                        writer.writeObjectStart(1);
                        entries_[i_entries_]->encode(writer);
                        writer.writeObjectEnd();
                    } else if (!entries_[i_entries_]->getTypeName().compare("deltix.timebase.api.messages.universal.L2EntryUpdate")) {
                        writer.writeObjectStart(2);
                        entries_[i_entries_]->encode(writer);
                        writer.writeObjectEnd();
                    } else if (!entries_[i_entries_]->getTypeName().compare("deltix.qsrv.hf.plugins.data.bittrex.types.BittrexTradeEntry")) {
                        writer.writeObjectStart(3);
                        entries_[i_entries_]->encode(writer);
                        writer.writeObjectEnd();
                    } else if (!entries_[i_entries_]->getTypeName().compare("deltix.timebase.api.messages.universal.BookResetEntry")) {
                        writer.writeObjectStart(4);
                        entries_[i_entries_]->encode(writer);
                        writer.writeObjectEnd();
                    } else {
                        throw runtime_error("Unknown class type");
                    }
                }
            }
            writer.writeArrayEnd();
        }
    }

    inline void clear() {
        Dx_PackageHeader::clear();
        entries_.clear();
        has_entries_ = false;
    }

    inline void setEntries(const vector<shared_ptr<NativeMessage>> &value) {
        this->entries_ = value;
        has_entries_ = true;
    }

    inline vector<shared_ptr<NativeMessage>>& getEntries() {
        return this->entries_;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_PackageHeader::toString() << ", ";
        return ss.str();
    };

    vector<shared_ptr<NativeMessage>> entries_;

    bool has_entries_ = false;
};

} // namespace dx_BITTREX::deltix::qsrv::hf::plugins::data::bittrex::types

#endif /* DX_BITTREX__DELTIX__QSRV__HF__PLUGINS__DATA__BITTREX__TYPES_DX_BITTREXPACKAGEHEADER_INC */
