#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_BOOKRESETENTRY_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_BOOKRESETENTRY_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_BaseEntry.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::universal {

class Dx_BookResetEntry : public Dx_BaseEntry {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.universal.BookResetEntry";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1c";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_BaseEntry::decode(reader);
        modelType_ = reader.readEnum8();
        side_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        Dx_BaseEntry::encode(writer);
        writer.writeEnum8(modelType_);
        writer.writeEnum8(side_);
    }

    inline void clear() {
        Dx_BaseEntry::clear();
        modelType_ = DxApi::ENUM_NULL;
        side_ = DxApi::ENUM_NULL;
    }

    inline void setModelType(int value) {
        this->modelType_ = value;
    }

    inline void setSide(int value) {
        this->side_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_BaseEntry::toString() << ", ";
        ss << "  modelType_: "; 
        if (modelType_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << modelType_; }
        ss << ", ";
        ss << "  side_: "; 
        if (side_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << side_; }
        return ss.str();
    };

    int modelType_;
    int side_;

};

} // namespace dx_BITTREX::deltix::timebase::api::messages::universal

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_BOOKRESETENTRY_INC */
