#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__SERVICE_DX_CONNECTIONSTATUSCHANGEMESSAGE_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__SERVICE_DX_CONNECTIONSTATUSCHANGEMESSAGE_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "src/codecs/NativeMessage.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::service {

class Dx_ConnectionStatusChangeMessage : public NativeMessage {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.service.ConnectionStatusChangeMessage";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1h";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        has_cause_ = reader.readUTF8(cause_);
        status_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        writer.writeUTF8(has_cause_ ? &cause_ : NULL);
        writer.writeEnum8(status_);
    }

    inline void clear() {
        cause_.clear();
        has_cause_ = false;
        status_ = DxApi::ENUM_NULL;
    }

    inline void setCause(const string &value) {
        this->cause_ = value;
        has_cause_ = true;
    }

    inline void setStatus(int value) {
        this->status_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << NativeMessage::toString() << ", ";
        ss << "  cause_: "; 
        if (!has_cause_) { ss << "[NULL]"; } else { ss << cause_; }
        ss << ", ";
        ss << "  status_: "; 
        if (status_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << status_; }
        return ss.str();
    };

    string cause_;
    int status_;

    bool has_cause_ = false;
};

} // namespace dx_BITTREX::deltix::timebase::api::messages::service

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__SERVICE_DX_CONNECTIONSTATUSCHANGEMESSAGE_INC */
