#ifndef DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L2ENTRYUPDATE_INC
#define DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L2ENTRYUPDATE_INC

#include <string>
#include <stdint.h>

#include "dxapi/dxapi.h"
#include "dfp/DecimalNative.hpp"
#include "Dx_BasePriceEntry.h"

using namespace std;
using namespace DxApi;

using namespace deltix::dfp;

namespace dx_BITTREX::deltix::timebase::api::messages::universal {

class Dx_L2EntryUpdate : public Dx_BasePriceEntry {
private:
    std::string __class_type__ = "deltix.timebase.api.messages.universal.L2EntryUpdate";
    std::string __class_guid__ = "64406423fb2b4ajpjsoe_1a";

public:
    virtual std::string & getTypeName() { return __class_type__; }
    virtual std::string & getGuid() { return __class_guid__; }

    virtual void decode(DataReader &reader) {
        Dx_BasePriceEntry::decode(reader);
        action_ = reader.readEnum8();
        level_ = reader.readInt16();
        side_ = reader.readEnum8();
    }

    virtual void encode(DataWriter &writer) {
        Dx_BasePriceEntry::encode(writer);
        writer.writeEnum8(action_);
        writer.writeInt16(level_);
        writer.writeEnum8(side_);
    }

    inline void clear() {
        Dx_BasePriceEntry::clear();
        action_ = DxApi::ENUM_NULL;
        level_ = DxApi::INT16_NULL;
        side_ = DxApi::ENUM_NULL;
    }

    inline void setAction(int value) {
        this->action_ = value;
    }

    inline void setLevel(int16_t value) {
        this->level_ = value;
    }

    inline void setSide(int value) {
        this->side_ = value;
    }

    virtual string toString() {
        stringstream ss;
        ss << Dx_BasePriceEntry::toString() << ", ";
        ss << "  action_: "; 
        if (action_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << action_; }
        ss << ", ";
        ss << "  level_: "; 
        if (level_ == DxApi::INT16_NULL) { ss << "[NULL]"; } else { ss << level_; }
        ss << ", ";
        ss << "  side_: "; 
        if (side_ == DxApi::ENUM_NULL) { ss << "[NULL]"; } else { ss << side_; }
        return ss.str();
    };

    int action_;
    int16_t level_;
    int side_;

};

} // namespace dx_BITTREX::deltix::timebase::api::messages::universal

#endif /* DX_BITTREX__DELTIX__TIMEBASE__API__MESSAGES__UNIVERSAL_DX_L2ENTRYUPDATE_INC */
